<template lang="pug">
mixin HeaderSortIcon
  i.mr-2.mt-1.header-icon.fa&attributes(attributes)

BaseAnimationGroup(:appear='true').row
  .col-12.py-3.justify-content-center.d-flex(key='noDns' v-if='$butils.isEmpty(dns)')
    span.alert.alert-secondary Please select an experiment area...
  template(v-else)
    .col-12(key='alarmCard')
      EditCard.x-alarms.w-100(title='Alarms').highlightOnFocus
        template(v-slot='card')
          li(key="filters").x-alarms-filters
            .row.my-1.d-flex.justify-content-center
              .col-auto.mt-1
                .btn-group(role='group' aria-label='Basic example').shadow-sm.border.rounded
                  button#f-critical.btn(type='button' :class="getButtonFilterClass('CRITICAL')"
                    @click="toggleSeverityFilter('CRITICAL')") Critical
                  button#f-error.btn(type='button' :class="getButtonFilterClass('ERROR')"
                    @click="toggleSeverityFilter('ERROR')") Error
                  button#f-warning.btn(type='button' :class="getButtonFilterClass('WARNING')"
                    @click="toggleSeverityFilter('WARNING')") Warning
                  button#f-info.btn(type='button' :class="getButtonFilterClass('INFO')"
                    @click="toggleSeverityFilter('INFO')") Info
                  button#f-masked.btn(type='button' :class="searchMasked ? 'btn-dark' : 'btn-light text-muted'"
                    @click="toggleMaskedFilter()") Masked
                  button#f-disabled.btn(type='button' :class="searchDisabled ? 'btn-dark' : 'btn-light text-muted'"
                    @click="toggleDisabledFilter()") Disabled
              .col-auto.mt-1
                .input-group
                  .input-group-prepend
                    span#regexp-filter.input-group-text Filter
                  input.form-control(v-model="regExpFilter" type='text' aria-describedby='regexp-filter')
                  .input-group-append
                    button.btn.btn-outline-secondary(type='button' @click="regExpFilter = null") Clear

          li(key="alarms").pb-3
            //- Spinner while data is loading
            BaseModalLoader(:isLoading="loading")
            table.table.table-sm.table-hover
              thead
                tr.table-head
                  //- first  th is for collapsible icon
                  th.clickable(scope='col' @click="setSorting('system')") System
                    +HeaderSortIcon()(:class="getSortingClass('system')")
                  th.clickable(scope='col' @click="setSorting('ident')") Device
                    +HeaderSortIcon()(:class="getSortingClass('ident')")
                  th.clickable(scope='col' @click="setSorting('message')") Message
                    +HeaderSortIcon()(:class="getSortingClass('message')")
                  th.clickable(scope='col' @click="setSorting('severity')") Severity
                    +HeaderSortIcon()(:class="getSortingClass('severity')")
                  th.clickable(scope='col' @click="setSorting('date')") Time
                    +HeaderSortIcon()(:class="getSortingClass('date')")
                  th(v-if='isScreenLG' scope='col') Masked
                  th(v-if='isScreenLG' scope='col') Disabled

              tbody(v-if="!alarms || (alarms && alarms.length === 0)")
                tr(key="noAlarmsToShow")
                  td(colspan="7").py-4.border
                    .h5 There are no alarms to show.
                    span(v-if="sumAllStats > 0") Please redefine your filters.
              tbody(v-else)
                tr(:key="alarm.ident" v-for="alarm in alarms")
                  td {{ alarm.system }}
                  td {{ alarm.ident }}
                  td
                    pre {{ alarm.message }}
                  td
                    .badge(:class="getSeverityBadgeClass(alarm.severityStr)")
                      span {{ alarm.severityStr }}
                  td {{ alarm.date | b-moment('MM-dd HH:mm:ss ZZ') }}
                  td(v-if='isScreenLG')
                    template(v-if="card.inEdit")
                      BaseToggle(:inEdit="true" :value="alarm.masked" :disabled="isSendingCommand"
                        @userEdit="changeAlarm('mask', alarm.ident)")
                    template(v-else)
                      i(v-show="alarm.masked").fas.fa-check
                  td(v-if='isScreenLG')
                    template(v-if="card.inEdit")
                      BaseToggle(:inEdit="true" :value="alarm.disabled" :disabled="isSendingCommand"
                        @userEdit="changeAlarm('disable', alarm.ident)")
                    template(v-else)
                      i(v-show="alarm.disabled").fas.fa-check
</template>

<script>

export { default } from './Alarms.vue.js';

</script>

<style lang='scss'>
.x-alarms {
  .table-head > th {
    border: 1px solid #dee2e6 !important;
  }

  .table {
    td, th {
      vertical-align: middle;
      text-align: center;
      font-size: 0.9rem;
    }
    td pre {
      text-align: left;
      vertical-align: middle;
      white-space: pre-wrap;
      margin-bottom: 0;
    }
  }

  .header-icon {
    float: right;
    margin-right: 0.5rem !important;
    margin-top: 0.25rem !important;
  }

  .i-deactivated {
    color: #888;
  }

  .x-alarms-filters {
    input:focus,
    .btn:focus {
      outline: none;
      box-shadow: none;
    }
  }
}
</style>
